% definirajmo roditelj/2
roditelj(stosija, ante).
roditelj(kresimir, ante).
roditelj(mirjana, lucija).
roditelj(ante, goran).
roditelj(ante, zoran).
roditelj(lucija, zeljko).
roditelj(zoran, tanja).
roditelj(zoran, marija).

% zatim slijedi musko/1
musko(ante).
musko(goran).
musko(kresimir).
musko(zeljko).
musko(zoran).

% i zensko/1
zensko(lucija).
zensko(marija).
zensko(mirjana).
zensko(stosija).
zensko(tanja).

% izvedimo i majka/2, otac/2, djed/2
majka(X, Y) :- roditelj(X, Y), zensko(X).
otac(X, Y) :- roditelj(X, Y), musko(X).
djed(X, Y) :- musko(X), roditelj(X, Z), roditelj(Z, Y).

% potom i sestra/2 i brat/2
sestra(X, Y) :- roditelj(Z, X), roditelj(Z, Y), zensko(X), X \= Y.
brat(X, Y) :- roditelj(Z, X), roditelj(Z, Y), musko(X), X \= Y.

% rekurzivno i potomak/2
potomak(X, Y) :- roditelj(Y, X).
potomak(X, Y) :- roditelj(Y, Z), potomak(X, Z).

% i zatim izvedeni ujak/2
ujak(X, Y) :- sestra(Z, X), musko(X), roditelj(Z, Y).
