% definirajmo roditelj/2 relaciju
roditelj(kresimir, darko).
roditelj(kresimir, lucija).
roditelj(tereza, darko).
roditelj(darko, vigor).
roditelj(darko, goran).
roditelj(vigor, ruzica).
roditelj(vigor, snjezana).

% nakon toga slijede jednostavne musko/1 i zensko/1 relacije
musko(kresimir).
musko(darko).
musko(vigor).
zensko(lucija).
zensko(tereza).
zensko(ruzica).
zensko(snjezana).

% izvedena relacija majka/2
majka(X, Y) :- roditelj(X, Y), zensko(X).

% izvedena relacija otac/2 (analogno majka/2)
otac(X, Y) :- roditelj(X, Y), musko(X).

% izveden potomak/2 (rekurzivna relacija!)
potomak(X, Y) :- roditelj(Y, X).
potomak(X, Y) :- roditelj(Y, Z), potomak(X, Z). 

% sestra/2
sestra(X, Y) :- roditelj(Z, X), roditelj(Z, Y), zensko(X), X \= Y.

% brat/2
brat(X, Y) :- roditelj(Z, X), roditelj(Z, Y), musko(X), X \= Y.

% ujak/2
ujak(X, Y) :- majka(Z, Y), brat(X, Z).
